﻿Imports System
Imports System.Text
Imports System.Management.Automation
Imports System.Management.Automation.Runspaces
Imports System.Security
Imports System.Collections.ObjectModel
Imports System.Diagnostics
Imports System.Collections

Module Main
    Sub Main()
        '管理者アカウントを指定
        Dim strAccount As String = "DOMAIN\Admin"
        'パスワードを指定
        Dim strPassword As String = "PASSWORD"
        'Hyper-Vサーバーを指定
        Dim strServer As String = "HvHost01"
        '実行するコマンドを指定
        Dim strRunCmd As String = "Get-VM | Out-String"
        Dim strRunCmd2 As String = "Get-VM" 'or C:\MyPowerShell.ps1
        'Invoke-Commandに埋め込み
        Dim strCmd As String = "" 'or C:\MyPowerShell.ps1
        'strCmd += "Set-Item WSMan:\LocalHost\Client\TrustedHosts -Value * -Force;"
        strCmd += "$AdminPassword = ConvertTo-SecureString '" & strPassword & "' -AsPlainText -Force;"
        strCmd += "$ObjectTypeName = 'System.Management.Automation.PSCredential';"
        strCmd += "$Cred = New-Object -TypeName $ObjectTypeName -ArgumentList '" & strAccount & "', $AdminPassword;"
        strCmd += "Invoke-Command -ComputerName " & strServer & " -ScriptBlock {" & strRunCmd & "} -Cred $Cred;"
        '非同期のコマンド指定
        Dim strAsyncCmds() As String = {"Export-VM –Name VM01 –Path D:\Exp", "Start-VM VM02", "Get-VM", "Start-VM VM03"}

        'コマンドを実行
        AsyncPowershell(strServer, strAccount, strPassword, strAsyncCmds)
        'RunPowerShell(strCmd)
        'RemotePowershell(strServer, strAccount, strPassword, strRunCmd)
        'RemotePipeline(strServer, strAccount, strPassword, strRunCmd2)
    End Sub

    Public Sub AsyncPowershell(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String, ByVal strCmds() As String)
        Dim objRunspacePool As RunspacePool = Nothing
        Try
            'パスワードを暗号化
            Dim objSecureString As New SecureString()
            For Each c As String In strPassword.ToCharArray()
                objSecureString.AppendChar(c)
            Next
            Dim objPSCredential As New PSCredential(strAccount, objSecureString)

            'WinRMを利用してリモートでPowerShellを実行
            Dim objUri As New Uri("http://" + strServer + ":5985/wsman")
            Dim objWSManConnectionInfo As New WSManConnectionInfo(objUri, "http://schemas.microsoft.com/powershell/Microsoft.PowerShell", objPSCredential)

            Dim intRunspace As Integer = strCmds.Length
            objRunspacePool = RunspaceFactory.CreateRunspacePool(1, intRunspace, objWSManConnectionInfo)
            'objRunspacePool.ApartmentState = Threading.ApartmentState.STA
            'objRunspacePool.ThreadOptions = PSThreadOptions.UseNewThread
            objRunspacePool.Open()

            Dim aryPowerShell As New ArrayList
            Dim aryIAsyncResult As New ArrayList
            Dim strCmd As String = ""
            For i As Integer = 0 To strCmds.Length - 1
                strCmd = strCmds(i)

                Dim objPowerShell As PowerShell = PowerShell.Create()
                objPowerShell.RunspacePool = objRunspacePool
                objPowerShell.AddScript(strCmd)
                objPowerShell.AddCommand("Out-String")
                'PowerShellコマンド実行
                Dim objIAsyncResult As IAsyncResult = objPowerShell.BeginInvoke()

                aryPowerShell.Add(objPowerShell)
                aryIAsyncResult.Add(objIAsyncResult)
            Next

            Do While (aryPowerShell.Count > 0)
                For i As Integer = 0 To aryPowerShell.Count - 1

                    Dim objPowerShell As PowerShell = aryPowerShell(i)
                    Dim objIAsyncResult As IAsyncResult = aryIAsyncResult(i)

                    If Not IsNothing(objPowerShell) Then
                        If objIAsyncResult.IsCompleted Then
                            Dim objResultCollection As PSDataCollection(Of PSObject) = objPowerShell.EndInvoke(objIAsyncResult)

                            'PowerShellコマンドの実行結果を出力
                            For Each objResult As PSObject In objResultCollection
                                Debug.WriteLine(objResult.ToString)
                            Next

                            'PowerShellのエラーを出力
                            Dim objErrors As Collection(Of ErrorRecord) = objPowerShell.Streams.Error.ReadAll
                            For Each objErrorRecord As ErrorRecord In objErrors
                                Debug.WriteLine(objErrorRecord.Exception.Message)
                            Next

                            objPowerShell.Dispose()
                            aryPowerShell.RemoveAt(i)
                            aryIAsyncResult.RemoveAt(i)
                            Exit For
                        End If
                    End If

                Next
                Threading.Thread.Sleep(100)
            Loop
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
        Finally
            objRunspacePool.Close()
        End Try
    End Sub

    Public Sub RemotePipeline(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String, strCmd As String, strKeys() As String, strValues() As String)
        'パスワードを暗号化
        Dim objSecureString As New SecureString()
        For Each c As String In strPassword.ToCharArray()
            objSecureString.AppendChar(c)
        Next
        Dim objPSCredential As New PSCredential(strAccount, objSecureString)

        'WinRMを利用してリモートでPowerShellを実行
        Dim objUri As New Uri("http://" + strServer + ":5985/wsman")
        Dim objWSManConnectionInfo As New WSManConnectionInfo(objUri, "http://schemas.microsoft.com/powershell/Microsoft.PowerShell", objPSCredential)
        Dim objRunspace As Runspace = RunspaceFactory.CreateRunspace(objWSManConnectionInfo)
        objRunspace.Open()
        Dim objPipeline As Pipeline = objRunspace.CreatePipeline

        Dim objCommand As New Command(strCmd)
        For i As Integer = 0 To strKeys.Length - 1
            Dim objCommandParameter As New CommandParameter(strKeys(i), strValues(i))
            objCommand.Parameters.Add(objCommandParameter)
        Next
        objPipeline.Commands.Add(objCommand)
        objPipeline.Commands.Add("Out-String")

        Try
            'PowerShellコマンドの実行結果を出力
            Dim objResultCollection As Collection(Of PSObject) = objPipeline.Invoke()
            For Each objResult As PSObject In objResultCollection
                Debug.WriteLine(objResult.ToString)
            Next
        Catch ex As Exception
            'PowerShellのエラーを出力
            Debug.WriteLine(ex.ToString)
        End Try

        objPipeline.Dispose()
        objRunspace.Close()
    End Sub

    Public Sub RemotePowershell(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String, strCmd As String)
        'パスワードを暗号化
        Dim objSecureString As New SecureString()
        For Each c As String In strPassword.ToCharArray()
            objSecureString.AppendChar(c)
        Next
        Dim objPSCredential As New PSCredential(strAccount, objSecureString)

        'WinRMを利用してリモートでPowerShellを実行
        Dim objUri As New Uri("http://" + strServer + ":5985/wsman")
        Dim objWSManConnectionInfo As New WSManConnectionInfo(objUri, "http://schemas.microsoft.com/powershell/Microsoft.PowerShell", objPSCredential)
        Dim objRunspace As Runspace = RunspaceFactory.CreateRunspace(objWSManConnectionInfo)
        objRunspace.Open()
        Dim objPowerShell As PowerShell = PowerShell.Create()
        objPowerShell.Runspace = objRunspace
        objPowerShell.AddScript(strCmd)

        'PowerShellコマンドの実行結果を出力
        Dim objResultCollection As Collection(Of PSObject) = objPowerShell.Invoke()
        For Each objResult As PSObject In objResultCollection
            'Debug.WriteLine(objResult.Properties("Name").Value)
            Debug.WriteLine(objResult.ToString)
        Next

        'PowerShellのエラーを出力
        Dim objErrors As Collection(Of ErrorRecord) = objPowerShell.Streams.Error.ReadAll
        For Each objErrorRecord As ErrorRecord In objErrors
            Debug.WriteLine(objErrorRecord.Exception.Message)
        Next

        objPowerShell.Dispose()
        objRunspace.Close()
    End Sub

    Public Sub RunPowerShell(ByVal strCmd As String)
        'PowerShellのエラーを取得するためのオブジェクト
        Dim objErrors As IList = Nothing
        Dim objRunspace As Runspace = RunspaceFactory.CreateRunspace()
        objRunspace.Open()
        Dim objRunspaceInvoke As RunspaceInvoke = New RunspaceInvoke(objRunspace)

        'PowerShellコマンドを実行
        Dim objResultCollection As Collection(Of PSObject) = objRunspaceInvoke.Invoke(strCmd, Nothing, objErrors)

        'PowerShellコマンドの実行結果を出力
        For Each objResult As PSObject In objResultCollection
            Debug.WriteLine(objResult.ToString)
        Next

        'PowerShellのエラーを出力
        For Each objError As PSObject In objErrors
            Dim objRecord As ErrorRecord = objError.BaseObject
            Debug.WriteLine(objRecord.Exception.Message)
        Next

        objRunspace.Close()
    End Sub

End Module
